
#include "imag0.h"

#ifndef _IMAG_H
#define _IMAG_H

timagf imagfalloc ();

tvent ventBaseDeImagf (timagf imagf);

void invierteGrImagen (tvent vent);

void cambiaGrImagen (tvent vent, int *conv);

void creaImagenPlana (timagf *nimag, int g, int tx, int ty);

void creaImagenMaxsReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry);

void creaImagenReducidaDeVentana (timagf *nimagr, tvent vent, int rx, int ry);

void creaImagenReducida (timagf *nimagr, timagf imag);

void creaImagenesReducidas (timagf *vimagr, timagf imag, int n);

void creaImagenAmpliadaConMargen (timagf *nimaga, tvent vent, int amph, int ampv,
                                  int marg, int grMarg);

void creaImagenAmpliada (timagf *nimaga, tvent vent, int amph, int ampv);

void copiaImagenDeVentana (timagf *nimag, tvent vent);

void destruyeVentana (tvent vent);

void destruyeImagen (timagf imag);

void imagenGiradaCDerecha (timagf *nimagg, tvent vent);

void imagenGiradaCIzquierda (timagf *nimagg, tvent vent);

void imagenGiradaMVuelta (timagf *nimagg, tvent vent);

void imagenEspejoV (timagf *nimage, tvent vent);

  /* ---------- reajusta ventana  ---------- */

void reajustaPix (tvent vent);

void ventanaCreceporelNorte (tvent vent, int dely);

void ventanaCreceporelSur (tvent vent, int dely);

/* ---------- ventana en/de ventana ... ---------- */

void ventanaEnVentana (tvent * nventi, tvent vent,
                        int dx, int dy, int tx, int ty);

void ventanaEnVentanaCabeIgl (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty);

void ventanaEnVentanaCabeMen (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty);

void ventanaLimpParalogrDeVentana (tvent * nventi, tvent vent,
                                  int inclH, int y0, int y1, int inclV, int x0, int x1);

void ventanaEnVentanaCentrada (tvent * nventi, tvent vent,
                               int dx, int dy);

void ventanaDeVentana (tvent * nventi, tvent vent,
                       int dx, int dy, int tx, int ty);

void ventanaDeVentanaCabeMen (tvent * nventi, tvent vent,
                              int dx, int dy, int tx, int ty);

void copiaVentana (tvent * nventi, tvent vent);

void copiaVentanaaImagen (timagf imag, tvent vent, int dx, int dy);

void ventanaEnVentanaLargHor (tvent * nventi, tvent vent, int dy, int ty);

void ventanaEnVentanaLargVer (tvent * nventi, tvent vent, int dx, int tx);

void ventanaEnVentanaLargVerInclLimpConMargen (tvent * nventi, tvent vent,
		                               int dxb, int txb, int inclvabs);

void ventanaAmpliaVentana (tvent * nventi, tvent vent,
                               int marg );

tvvents vventsalloc (int n);

void vventsfree (tvvents vvents);

void describeVventanas (tvvents vvents);

void describeVentana (tvent vent);

void desplazamientosBase (int *dx, int *dy, int* tx, int *ty, tvent vent);

void desplazamientosBase2 (int *dx, int *dy, tvent vent);

// void ponerCarhisgrenVentana (tvent vent, tdcaracHistoGr carHisGr);

void ponerConvenVentana (tvent vent, int *conv);

int * tenerConvSobreVentana (tvent vent);

// tdcaracHistoGr carhisgrDeVentana (tvent vent);

int ktamDeVentana (tvent vent);

int valorintEncomImagen (char * nvariable, timagf imagf);

void unionGventanas (tvent * nvent, tvent vent1, tvent vent2);

void ventanaAlrededor (tvent *nvent, tvent vent, int tx, int ty, int escala) ;

void ventanaVertDeVentanaIncl (tvent * nventi, tvent vent);

void ventanaLimpConMargenDeVentanaIncl (tvent * nventi, tvent vent, int fondo, int marg);

void ventanaLimpConMargenPara2vents (tvent * nventi, tvent vent1, tvent vent2,
                                     int delta2resp1, int fondo, int marg);

void ventanaLimpDeVentanaIncl (tvent * nventi, tvent vent, int fondo);

void cdgVentana (int *cdgx, int *cdgy, tvent vent, int ampl);

void maximoenVentana (int *mxx, int *mxy, int *mxp, tvent vent);

tvent seleccionaSubventana (tvent vent, char *selec);

Boolean ventanaMenor(tvent v1, tvent v2);

Boolean ventanaAlsur(tvent v1, tvent v2);

tvvents vventDeLista (lista l);

void umbralizaVentana (tvent vent, int gr);

void ajustadaV (tvent *nvent, tvent vent, int gr);

void ajustadaH (tvent *nvent, tvent vent, int gr);

void ajustadaVH (tvent *nvent, tvent vent, int gr);

void ajustadaVHext (tvent *nvent, tvent vent, tvent ventmx, int gr);

// callback, desde grises? --

extern int (*fondoClaro) (tvent);

#endif /* _IMAG_H */
